package org.w3c.rdf.implementation.syntax.sirpac;

public class QName {

  String namespace;
  String localName;
  
  public QName(String ns, String ln) {
    namespace = ns;
    localName = ln;
  }
  
  public QName(String ln) {
    namespace = null;
    localName = ln;
  }
  
  public int hashCode() {
    return getName().hashCode();
  }

  public String getName() {

    return namespace == null ? localName : namespace + localName;
  }

  public String toString() {

    return getName();
  }
  
  public String getNamespace() {

    return namespace;
  }

  public String getLocalName() {
    
    return localName;
  }

  public boolean equals (Object that) {
    
    if (this == that) {
      return true;
    }
    if (that == null) {
      return false;
    }

    if(that instanceof QName) {

      QName t = (QName)that;
      
      // resources are equal iff this.getURI() == that.getURI()
      // the case distinction below is for optimization only to avoid unnecessary string concatenation
      
      boolean b;
      
      if(namespace == null) {
	if(t.getNamespace() == null)
	  b = localName.equals(t.getLocalName());
	else // maybe "that" did not detect names
	  b = localName.equals(t.getName());
      } else {
	if(t.getNamespace() != null)
	  b = localName.equals(t.getLocalName()) && namespace.equals(t.getNamespace());
	else // maybe "this" did not detect names
	  b = getName().equals(t.getName());
      }

      return b;

    } else
      return getName().equals(String.valueOf(that));
  }
  
}
